<template>
    <div>
        <div class="row ml-2">
            <router-link to="/products" class="btn btn-primary">All Products</router-link>
        </div>
        <div class="row justify-content-center">
            <div class="col-xl-10 col-lg-12 col-md-12">
                <div class="card shadow-sm my-5">
                    <div class="card-body p-0">
                        <div class="row">
                            <div class="col-lg-12">
                                <div class="login-form">
                                    <div class="text-center">
                                        <h1 class="h4 text-gray-900 mb-4">Add Product</h1>
                                    </div>
                                    <form class="create" @submit.prevent="productInsert">
                                        <div class="form-row">
                                            <div class="col-md-6">
                                                <label for="exampleFormControlSelect1">Product Name</label>
                                                <input type="text" class="form-control"  placeholder="Enter Your Product Name" v-model="form.product_name">
                                                <small class="text-danger" v-if="errors.product_name"> {{ errors.product_name[0] }} </small>
                                            </div>


                                            <div class="col-md-6">
                                                <label for="exampleFormControlSelect1">Product Code</label>
                                                <input type="text" class="form-control"  placeholder="Enter Your Product Code" v-model="form.product_code">
                                                <small class="text-danger" v-if="errors.product_code"> {{ errors.product_code[0] }} </small>
                                            </div>

                                        </div>


                                <div class="form-group">
                                    <div class="form-row">
                                        <div class="col-md-6">
                                            <label for="exampleFormControlSelect1">Product Category</label>
                                            <select class="form-control" id="exampleFormControlSelect1" v-model="form.category_id">
                                                <option :value="category.id" v-for="category in categories">{{ category.category_name }}</option>

                                            </select>

                                        </div>
                                        <div class="col-md-6">
                                            <label for="exampleFormControlSelect2">Product Supplier</label>
                                            <select class="form-control" id="exampleFormControlSelect2" v-model="form.supplier_id">

                                                <option :value="supplier.id" v-for="supplier in suppliers">{{ supplier.name }}</option>

                                            </select>
                                        </div>

                                    </div>
                                </div>

                                <div class="form-group">
                                    <div class="form-row">
                                        <div class="col-md-4">
                                            <label for="exampleFormControlSelect1">Product Root</label>
                                            <input type="text" class="form-control"   v-model="form.root">
                                            <small class="text-danger" v-if="errors.root"> {{ errors.root[0] }} </small>
                                        </div>

                                        <div class="col-md-4">
                                            <label for="exampleFormControlSelect1">Buying Price</label>
                                            <input type="text" class="form-control"   v-model="form.buying_price">
                                            <small class="text-danger" v-if="errors.buying_price"> {{ errors.buying_price[0] }} </small>
                                        </div>

                                        <div class="col-md-4">
                                            <label for="exampleFormControlSelect1">Selling Price</label>
                                            <input type="text" class="form-control"  v-model="form.selling_price">
                                            <small class="text-danger" v-if="errors.selling_price"> {{ errors.selling_price[0] }} </small>
                                        </div>

                                    </div>
                                </div>

                                <div class="form-group">

                                    <div class="form-row">
                                        <div class="col-md-6">
                                            <label for="exampleFormControlSelect1">Buying Date</label>
                                            <input type="date" class="form-control"  v-model="form.buying_date">
                                            <small class="text-danger" v-if="errors.buying_date"> {{ errors.buying_date[0] }} </small>
                                        </div>


                                        <div class="col-md-6">
                                            <label for="exampleFormControlSelect1">Product Quantity</label>
                                            <input type="text" class="form-control"  placeholder="Enter Your Quantity" v-model="form.product_quantity">
                                            <small class="text-danger" v-if="errors.product_quantity"> {{ errors.product_quantity[0] }} </small>
                                        </div>

                                    </div>
                                </div>

                                <div class="form-group">

                                    <div class="form-row">
                                        <div class="col-md-6">
                                            <input type="file" class="custom-file-input" id="customFile" @change="onFileSelected">

                                            <small class="text-danger" v-if="errors.image"> {{ errors.image[0] }} </small>
                                            <label class="custom-file-label" for="customFile">Choose file</label>
                                        </div>

                                        <div class="col-md-6">
                                            <img :src="form.image" style="height: 40px; width: 40px;">
                                        </div>

                                    </div>
                                </div>
                                        <div class="form-group">
                                            <button type="submit" class="btn btn-primary btn-block">Submit</button>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    name: "create",
    created() {
        if (!User.loggedIn()) {
            this.$router.push('/');
        }
        axios.get('/api/category/')
            .then(({data}) => (this.categories = data))
        axios.get('/api/supplier/')
            .then(({data}) => (this.suppliers = data))
    },
    data() {
        return {
            form: {
                product_name: null,
                product_code: null,
                category_id: null,
                supplier_id: null,
                root: null,
                buying_price: null,
                selling_price: null,
                buying_date: null,
                image: null,
                product_quantity: null
            },
            errors: {},
            categories:[],
            suppliers:[],
        }
    },
    methods: {
        productInsert() {
            axios.post('/api/product', this.form)
                .then(() => {
                    NotificationHelper.success();
                    this.$router.push({name: 'products'});
                })
                .catch(error => this.errors = error.response.data.errors)
        },
        onFileSelected(event){
            let file = event.target.files[0];
            if (file.size > 1048770) {
                NotificationHelper.image_validation()
            }else{
                let reader = new FileReader();
                reader.onload = event =>{
                    this.form.image = event.target.result
                    console.log(event.target.result);
                };
                reader.readAsDataURL(file);
            }
        },

    }
}
</script>

<style scoped>

</style>
